﻿
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.IO
Imports System.Text
Imports System.Xml

Imports MySql.Data
Imports MySql.Data.MySqlClient

Public Structure XLap
   Public KeyName As String
   Public LapNo As String
   Public S1 As String
   Public S2 As String
   Public S3 As String
   Public LapTime As String
End Structure

Public Class rFactorSLMain

   ' -- ALWAYS WATCH OUT FOR THE FUCKED UPED WAY OF DOUBLE CONVERSIONS !!!

   Public Const APP_NAME As String = "rFactor Session Loader VB for Windows"
   Public Const APP_VERSION As String = "2.124"
   Public Const APP_DB_VERSION As String = "2.004"
   Public Const APP_CONFIG_FILE As String = "rFactorSL.cfg"
   Public Const APP_LOG_FILE As String = "rFactorSL.log"
   Public Const APP_GRID_FOLDER As String = "GridInfo"
   Public Const APP_LOG_FOLDER As String = "Logs"
   Public Const APP_TRACK_FOLDER As String = "TrackData"

   Public FirstLoad As Boolean = True
   Public StopLoader As Boolean = False

   Public DSC As Char = "/"

   Public CycleTimeout As Integer = 123

   Public CDS As String = ","
   Public CurrentPath As String = ""
   Public HistoryLogFile As String = ""
   Public LapsTable As String = "xlaps"
   Public SqlConnString As String = ""

   Public TotalLapsPos1 As Integer = 0

   Public Config As New Dictionary(Of String, String)
   Public Session As New Dictionary(Of String, String)
   Public LapCache As New Dictionary(Of String, XLap)

   Private Sub rFactorSLMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      Dim OS As String = Environment.OSVersion.ToString

      ' -- get system directory separator
      DSC = Path.DirectorySeparatorChar

      ' -- get current working directory
      CurrentPath = My.Computer.FileSystem.CurrentDirectory

      ' -- get system locale decimal separator
      CDS = UtilGetDecimalSeparator()

      ' -- delete obsolete files
      UtilDeleteFile(CurrentPath & DSC & APP_LOG_FILE)

      ' -- create required folders
      UtilCreateFolder(APP_GRID_FOLDER)
      UtilCreateFolder(APP_LOG_FOLDER)
      UtilCreateFolder(APP_TRACK_FOLDER)

      WriteLogFile("i", "{Main} Loader Name: " & APP_NAME)
      WriteLogFile("i", "{Main} Loader Version: " & APP_VERSION & " beta")
      WriteLogFile("i", "{Main} OS Version: " & OS)
      WriteLogFile("i", "{Main} Loading configuration from (" & CurrentPath & DSC & APP_CONFIG_FILE & ") ...")

      ' -- load user configuration
      XmlLoadConfig()

      WriteLogFile("i", "{Main} System Config: Directory Separator Character = '" & DSC & "'")
      WriteLogFile("i", "{Main} System Config: Culture Decimal Separator = '" & CDS & "'")

      Me.Text &= " (" & APP_VERSION & " beta) " & Config("EventName")

      labelEventName.Text = "Event: " & Config("EventName")
      labelCycleTimeoutValue.Text = ": " & Replace(Format((CycleTimeout / 1000), "0.000"), ",", ".") & " Sec."

      textboxScoringSource.Text = Config("xmlURL")
      textboxSQLHost.Text = Config("sqlHost")
      textboxSQLPort.Text = Config("sqlPort")
      textboxSQLDatabase.Text = Config("dbName")
      textboxSQLUser.Text = Config("dbWriter")
      textboxSSLMode.Text = Config("sslMode")

      Dim LogAIInfo As String = ""
      If Config("LogAI") = "1" Then LogAIInfo = "HotlapsAI=YES"

      labelOptions.Text = "Options: LoadSQL=YES " & LogAIInfo

      ' -- construct sql connection string
      SqlConnString = "Server=" & Config("sqlHost") & ";Port=" & Config("sqlPort") & ";Username=" & Config("dbWriter") & ";Password=" & Config("dbWriterPass") & ";Database=" & Config("dbName") & ";SslMode=" & Config("sslMode")

      ' -- process command line arguments
      Dim CommandLineArguments() As String
      Dim ArgumentCount As Integer
      CommandLineArguments = System.Environment.GetCommandLineArgs
      For ArgumentCount = 0 To UBound(CommandLineArguments)
         Select Case CommandLineArguments(ArgumentCount).ToLower
            Case "-autorun"
               ' -- start loader automatically upon user request
               UtilStartLoader()
         End Select
      Next ArgumentCount

   End Sub

   Private Function UtilDeleteFile(ByVal FilePath As String) As Integer
      Try
         If File.Exists(FilePath) Then
            File.Delete(FilePath)
         End If
      Catch ex As Exception
         WriteLogFile("e", "{UtilDeleteFile} " & ex.Message & " - File: (" & FilePath & ")")
         Return -1
      End Try
   End Function

   Private Function UtilCreateFolder(ByVal FolderPath As String) As Integer
      Try
         If Directory.Exists(FolderPath) = False Then
            Directory.CreateDirectory(FolderPath)
         End If
      Catch ex As Exception
         WriteLogFile("e", "{UtilCreateFolder} " & ex.Message & " - Folder: (" & FolderPath & ")")
         Return -1
      End Try
   End Function

   Private Function XmlLoadConfig() As Integer
      Config.Add("EventName", "")
      Config.Add("CycleTimeout", "")
      Config.Add("Chill", "")
      Config.Add("xmlURL", "")
      Config.Add("sqlHost", "")
      Config.Add("sqlPort", "")
      Config.Add("dbName", "")
      Config.Add("dbWriter", "")
      Config.Add("dbWriterPass", "")
      Config.Add("sslMode", "")
      Config.Add("connPrefix", "")
      Config.Add("connAddress", "")
      Config.Add("connPort", "")
      Config.Add("LogAI", "")
      Dim XmlDoc As New XmlDocument
      Dim XmlPath As String = ""
      Try
         If File.Exists(CurrentPath & DSC & APP_CONFIG_FILE) Then
            XmlDoc.Load(CurrentPath & DSC & APP_CONFIG_FILE)

            XmlPath = "rFactorSL/Common/EventName"
            Config("EventName") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("EventName"))

            XmlPath = "rFactorSL/Common/CycleTimeout"
            Config("CycleTimeout") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            CycleTimeout = CStr2Int(Config("CycleTimeout"))
            If CycleTimeout < 123 Then
               CycleTimeout = 123
               Config("CycleTimeout") = CycleTimeout.ToString()
            End If
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & CycleTimeout)

            XmlPath = "rFactorSL/Common/Chill"
            Config("Chill") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("Chill"))

            XmlPath = "rFactorSL/CurrentScoringSource/xmlURL"
            Config("xmlURL") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("xmlURL"))

            XmlPath = "rFactorSL/MySQL/sqlHost"
            Config("sqlHost") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("sqlHost"))

            XmlPath = "rFactorSL/MySQL/sqlPort"
            Config("sqlPort") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("sqlPort"))

            XmlPath = "rFactorSL/MySQL/dbName"
            Config("dbName") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("dbName"))

            XmlPath = "rFactorSL/MySQL/dbWriter"
            Config("dbWriter") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("dbWriter"))

            XmlPath = "rFactorSL/MySQL/dbWriterPass"
            Config("dbWriterPass") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = **************")

            XmlPath = "rFactorSL/MySQL/sslMode"
            Config("sslMode") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("sslMode"))

            XmlPath = "rFactorSL/DedicatedServer/connPrefix"
            Config("connPrefix") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("connPrefix"))

            XmlPath = "rFactorSL/DedicatedServer/connAddress"
            Config("connAddress") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("connAddress"))

            XmlPath = "rFactorSL/DedicatedServer/connPort"
            Config("connPort") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("connPort"))

            XmlPath = "rFactorSL/Hotlaps/LogAI"
            Config("LogAI") = XmlDoc.SelectSingleNode(XmlPath).InnerXml
            WriteLogFile("i", "{XmlLoadConfig} User Config: " & XmlPath & " = " & Config("LogAI"))
         Else
            WriteLogFile("w", "{XmlLoadConfig} Configuration file not found: (" & CurrentPath & DSC & APP_CONFIG_FILE & ")")
         End If
         XmlDoc = Nothing
         Return 0
      Catch ex As Exception
         XmlDoc = Nothing
         WriteLogFile("e", "{XmlLoadConfig} Uncaught exception (uups - shit happens): " & ex.Message)
         Return -1
      End Try
   End Function

   Private Sub Worker()
      Dim CycleStart As Date = Now

      Dim DoubleSeizure As Boolean = False
      Dim DoubleSeizurePos As Integer = 201
      Dim SqlConn As New MySqlConnection
      Dim SqlSlotIDs As New Dictionary(Of String, String)
      Dim SqlNewSlot As Boolean = False
      Dim XmlDriversNames As New List(Of String)
      Dim XmlSlotIDs As New List(Of String)
      Dim XmlScoring As New XmlDocument
      Dim XmlScoringValid As Boolean = True
      Dim XmlSlots As XmlNodeList
      Dim XmlSlotData As New Dictionary(Of String, String)

      UtilLabelWriteText(labelCycleStartValue, ": " & CycleStart.ToString("dd.MM.yyyy HH:mm:ss.fff"))

      Try
         ' -- load current scoring xml file
         Try
            XmlScoring.Load(Config("xmlURL"))
            If FirstLoad = True Then
               FirstLoad = False
               WriteLogFile("i", "{Worker} Current Scoring was laoded for the first time from (" & Config("xmlURL") & ").")
            End If
         Catch ex As Exception
            XmlScoringValid = False
            WriteLogFile("w", "{Worker} " & ex.Message & " - Loading Current Scoring from (" & Config("xmlURL") & ").")
         End Try

         ' -- only continue if xml scoring data is valid
         If XmlScoringValid = True Then
            Dim XmlServerState As String = XmlScoring.SelectSingleNode("rFactorScoring/SessionInfo/ServerState").InnerXml
            Dim XmlSessionStart As String = XmlScoring.SelectSingleNode("rFactorScoring/SessionInfo/SessionStart").InnerXml

            If XmlSessionStart <> "" And XmlSessionStart <> "-1" And XmlSessionStart <> "0" Then
               XmlGetSessionInfos(XmlScoring)

               XmlWriteGridInfo(XmlScoring)

               Dim SessionName As String = UtilSetSessionName(Session("GameID"), Session("SessionID"))

               UtilLabelWriteText(labelGameVersionValue, ": " & Session("GameVersion"))
               UtilLabelWriteText(labelPluginVersionValue, ": " & Session("PluginVersion"))
               UtilLabelWriteText(labelTrackNameValue, ": " & Session("TrackName"))
               UtilLabelWriteText(labelSessionInfoValue, ": " & SessionName & " (" & UtilSetSessionState(Session("SessionState")) & ")")
               UtilLabelWriteText(labelSessionStatusValue, ": " & UtilSetSessionStatus(Session("SessionTime"), Session("SessionEnd"), Session("CurLaps"), Session("MaxLaps")))

               ' -- set common file names
               HistoryLogFile = APP_LOG_FOLDER & DSC & XmlSessionStart & "-" & Replace(SessionName, " ", "-") & ".log"

               ' -- open sql connection
               SqlConn = SqlConnOpen()

               If SqlConn.State = ConnectionState.Open Then
                  ' -- display sql state
                  UtilLabelWriteText(labelSQLState, "SQL Connection State: " & SqlConn.State.ToString)

                  ' -- get session start time from `sessioninfos`
                  Dim SqlStartTime As String = SqlSessionGetStartTime(SqlConn)

                  ' -- manage table `sessioninfos`
                  SqlSessionUpdate(SqlConn)

                  ' -- clear tables `slots` `xlaps` and `racelaps` due to session change
                  If CStr2Int(Session("SessionState")) < 5 And SqlStartTime <> "-1" And SqlStartTime <> XmlSessionStart Then
                     UtilMonitorAdd(Now & ": " & XmlSessionStart & " - " & SessionName)

                     WriteLogFile("i", "{Worker} Session change detected.")
                     WriteLogFile("i", "{Worker} SQL Start Time: " & SqlStartTime)
                     WriteLogFile("i", "{Worker} XML Start Time: " & XmlSessionStart)
                     WriteLogFile("i", "{Worker} XML Game Phase: " & Session("SessionState"))

                     SqlClearTable(SqlConn, "slots")
                     WriteLogFile("i", "{Worker} Clearing table `slots` due to session change.")

                     SqlClearTable(SqlConn, "racelaps")
                     WriteLogFile("i", "{Worker} Clearing table `racelaps` due to session change.")

                     SqlClearTable(SqlConn, "xlaps")
                     WriteLogFile("i", "{Worker} Clearing table `xlaps` due to session change.")

                     SqlHotlapsReset(SqlConn, "RESETALL")

                     LapCache.Clear()

                     TotalLapsPos1 = 0
                  End If

                  ' -- get all slot IDs from `slots`
                  SqlSlotIDs = SqlSlotsGetSlotIDs(SqlConn)

                  ' -- get all xml slot nodes
                  XmlSlots = XmlScoring.SelectNodes("rFactorScoring/Slots/Slot")

                  ' -- process slot data for each slot
                  For Each XmlSlot As XmlNode In XmlSlots
                     ' -- assuming there will be no double seizure
                     DoubleSeizure = False

                     ' -- clear dic before each cycle
                     XmlSlotData.Clear()

                     ' -- add slot data to dic
                     XmlSlotData.Add("SlotID", XmlSlot.SelectSingleNode("SlotID").InnerXml)
                     XmlSlotData.Add("Place", XmlSlot.SelectSingleNode("Place").InnerXml)
                     XmlSlotData.Add("DriverName", XmlSlot.SelectSingleNode("DriverName").InnerXml)
                     XmlSlotData.Add("VehicleClass", XmlSlot.SelectSingleNode("VehicleClass").InnerXml)
                     XmlSlotData.Add("VehicleName", XmlSlot.SelectSingleNode("VehicleName").InnerXml)
                     XmlSlotData.Add("Control", XmlSlot.SelectSingleNode("Control").InnerXml)
                     XmlSlotData.Add("Laps", XmlSlot.SelectSingleNode("Laps").InnerXml)
                     XmlSlotData.Add("LapStart", XmlSlot.SelectSingleNode("LapStart").InnerXml)
                     XmlSlotData.Add("LapDist", XmlSlot.SelectSingleNode("LapDist").InnerXml)
                     XmlSlotData.Add("Sector", XmlSlot.SelectSingleNode("Sector").InnerXml)
                     XmlSlotData.Add("CurS1", XmlSlot.SelectSingleNode("CurS1").InnerXml)
                     XmlSlotData.Add("CurS2", UtilCalcSectorTime(XmlSlot.SelectSingleNode("CurS2").InnerXml, XmlSlot.SelectSingleNode("CurS1").InnerXml))
                     XmlSlotData.Add("LastS1", XmlSlot.SelectSingleNode("LastS1").InnerXml)
                     XmlSlotData.Add("LastS2", UtilCalcSectorTime(XmlSlot.SelectSingleNode("LastS2").InnerXml, XmlSlot.SelectSingleNode("LastS1").InnerXml))
                     XmlSlotData.Add("LastS3", UtilCalcSectorTime(XmlSlot.SelectSingleNode("LastS3").InnerXml, XmlSlot.SelectSingleNode("LastS2").InnerXml))
                     XmlSlotData.Add("LastLap", XmlSlot.SelectSingleNode("LastLap").InnerXml)
                     XmlSlotData.Add("BestS1", XmlSlot.SelectSingleNode("BestS1").InnerXml)
                     XmlSlotData.Add("BestS2", UtilCalcSectorTime(XmlSlot.SelectSingleNode("BestS2").InnerXml, XmlSlot.SelectSingleNode("BestS1").InnerXml))
                     XmlSlotData.Add("BestS3", UtilCalcSectorTime(XmlSlot.SelectSingleNode("BestS3").InnerXml, XmlSlot.SelectSingleNode("BestS2").InnerXml))
                     XmlSlotData.Add("BestLap", XmlSlot.SelectSingleNode("BestLap").InnerXml)
                     XmlSlotData.Add("GapTime", XmlSlot.SelectSingleNode("GapTime").InnerXml)
                     XmlSlotData.Add("GapLaps", XmlSlot.SelectSingleNode("GapLaps").InnerXml)
                     XmlSlotData.Add("IntTime", XmlSlot.SelectSingleNode("IntTime").InnerXml)
                     XmlSlotData.Add("IntLaps", XmlSlot.SelectSingleNode("IntLaps").InnerXml)
                     XmlSlotData.Add("InPits", XmlSlot.SelectSingleNode("InPits").InnerXml)
                     XmlSlotData.Add("InBox", XmlSlot.SelectSingleNode("InBox").InnerXml)
                     XmlSlotData.Add("Pitstops", XmlSlot.SelectSingleNode("Pitstops").InnerXml)
                     XmlSlotData.Add("Penalties", XmlSlot.SelectSingleNode("Penalties").InnerXml)
                     XmlSlotData.Add("FinishStatus", XmlSlot.SelectSingleNode("FinishStatus").InnerXml)
                     XmlSlotData.Add("VehicleSpeed", XmlSlot.SelectSingleNode("VehicleSpeed").InnerXml)
                     XmlSlotData.Add("PosX", XmlSlot.SelectSingleNode("PosX").InnerXml)
                     XmlSlotData.Add("PosY", XmlSlot.SelectSingleNode("PosY").InnerXml)

                     ' -- remember xml active slot IDs for further processing
                     If XmlSlotIDs.Contains(XmlSlotData("SlotID")) = False Then
                        XmlSlotIDs.Add(XmlSlotData("SlotID"))
                     End If

                     ' -- remember xml active driver for further processing and double seizure protection
                     If XmlDriversNames.Contains(XmlSlotData("DriverName")) = False Then
                        XmlDriversNames.Add(XmlSlotData("DriverName"))
                     Else
                        If SessionName.Contains("Race") = False Then
                           DoubleSeizure = True
                           XmlSlotData("DriverName") &= " (" & XmlSlotData("Place") & ")"
                           XmlSlotData("VehicleName") = "+++ Double Seizure - Data will be ignored +++"
                           XmlSlotData("Laps") = "0"
                           XmlSlotData("Place") = DoubleSeizurePos.ToString()
                           XmlSlotData("FinishStatus") = "3"
                           DoubleSeizurePos += 1
                        End If
                     End If

                     ' -- manage table `slots`
                     If SqlSlotIDs.ContainsKey(XmlSlotData("SlotID")) = True Then
                        SqlSlotsUpdate(SqlConn, XmlSlotData)
                     Else
                        SqlSlotsInsert(SqlConn, XmlSlotData)
                        If SessionName.Contains("Race") = False Then
                           SqlNewSlot = True
                        End If
                     End If

                     If DoubleSeizure = True Then
                        Continue For
                     End If

                     Dim XmlSlotLaps As Integer = CStr2Int(XmlSlotData("Laps"))

                     ' -- manage tables `xlaps` or `racelaps`
                     If CStr2Dbl(XmlSlotData("LastS1")) > 0.0R And CStr2Dbl(XmlSlotData("LastS2")) > 0.0R And CStr2Dbl(XmlSlotData("LastLap")) > 0.0R Then
                        If XmlSlotLaps > SqlLapsGetLapNo(SqlConn, XmlSlotData("SlotID"), XmlSlotData("DriverName")) Then
                           SqlLapsInsert(SqlConn, LapsTable, XmlSlotData)
                        End If
                     End If

                     ' -- manage table `hotlaps` ... changed from BestLap values to LastLap values on 07.12.2012
                     If CStr2Dbl(XmlSlotData("LastS1")) > 0.0R And CStr2Dbl(XmlSlotData("LastS2")) > 0.0R And CStr2Dbl(XmlSlotData("LastLap")) > 0.0R Then
                        Dim HotlapStatus As String = SqlHotlapsGetStatus(SqlConn, XmlSlotData)
                        Select Case HotlapStatus
                           Case "INSERT"
                              SqlHotlapsInsert(SqlConn, XmlSlotData)

                           Case "UPDATE"
                              SqlHotlapsUpdate(SqlConn, XmlSlotData)

                           Case "UPCOUNT"
                              SqlHotlapsUpcount(SqlConn, XmlSlotData)
                        End Select
                     End If
                  Next ' -- For Each XmlSlot As XmlNode In XmlSlots

                  ' -- reset `xlaps` and `hotlaps` data due to rejoin
                  If SqlNewSlot = True Then
                     If XmlDriversNames.Count > 0 Then
                        For Each XmlDriverName As String In XmlDriversNames
                           If SqlSlotIDs.ContainsValue(XmlDriverName) = False Then
                              SqlClearXLaps(SqlConn, XmlDriverName)
                              SqlHotlapsReset(SqlConn, XmlDriverName)
                           End If
                        Next
                     End If
                  End If

                  ' -- clear obsolete slots
                  If XmlSlotIDs.Count > 0 Then
                     For Each SqlSlotID As String In SqlSlotIDs.Keys
                        If XmlSlotIDs.Contains(SqlSlotID) = False Then
                           SqlSlotsDelete(SqlConn, SqlSlotID)
                        End If
                     Next
                  Else
                     SqlSlotsDelete(SqlConn, 105)
                  End If

                  ' -- close sql connection
                  SqlConnClose(SqlConn)
               Else ' -- If SqlConn.State = ConnectionState.Open Then
                  UtilLabelWriteText(labelSQLState, "SQL Connection State: " & SqlConn.State.ToString)
               End If ' -- If SqlConn.State = ConnectionState.Open Then
            Else ' -- If XmlScoringValid = True Then
               SqlConn = SqlConnOpen()
               If SqlConn.State = ConnectionState.Open Then
                  SqlSessionUpdateStatus(SqlConn, XmlServerState, XmlSessionStart)
                  SqlConnClose(SqlConn)
               End If
            End If
         End If ' -- If XmlScoringValid = True Then

         ' -- calculate and display cycle statistics
         Dim CycleStop As Date = Now
         UtilLabelWriteText(labelCycleStopValue, ": " & CycleStop.ToString("dd.MM.yyyy HH:mm:ss.fff"))
         Dim CycleDuration As Global.System.TimeSpan = CycleStop.Subtract(CycleStart)
         UtilLabelWriteText(labelCycleDurationValue, ": " & Replace(Format(CycleDuration.TotalSeconds, "0.000"), ",", ".") & " Sec.")
         UtilLabelWriteText(labelCycleTotalValue, ": " & Replace(Format(CycleDuration.TotalSeconds + (CycleTimeout / 1000.0), "0.000"), ",", ".") & " Sec.")

         Threading.Thread.Sleep(CycleTimeout)
      Catch ex As Exception
         WriteLogFile("e", "{Worker} Uncaught exception (uups - shit happens): " & ex.Message)
      Finally
         ' -- clean-up
         SqlConn.Dispose()
         SqlSlotIDs = Nothing
         XmlDriversNames = Nothing
         XmlSlotIDs = Nothing
         XmlScoring = Nothing
         XmlSlots = Nothing
         XmlSlotData = Nothing
         GC.Collect()
      End Try
   End Sub

   Private Function XmlGetSessionInfos(ByRef XmlDoc As XmlDocument) As Integer
      Dim XmlSessionInfos As XmlNodeList
      Try
         Session.Clear()
         Session.Add("GameID", "0")
         Session.Add("GameVersion", "")
         Session.Add("PluginVersion", "")
         Session.Add("ServerStart", "0")
         Session.Add("ServerState", "0")
         Session.Add("SessionStart", "0")
         Session.Add("SessionID", "0")
         Session.Add("SessionState", "0")
         Session.Add("TrackName", "")
         Session.Add("TrackLength", "0.0")
         Session.Add("SessionTime", "0.0")
         Session.Add("SessionEnd", "0.0")
         Session.Add("CurLaps", "0")
         Session.Add("MaxLaps", "0")
         Session.Add("NumVehicles", "0")
         Session.Add("InGameStart", "0")
         Session.Add("YellowFlagState", "0")
         Session.Add("SectorFlags", "0::0::0")
         Session.Add("InRealtime", "0")
         Session.Add("StartLight", "0")
         Session.Add("NumRedLights", "0")
         Session.Add("PlayerName", "")
         Session.Add("PlrFileName", "")
         Session.Add("DarkCloud", "0.0")
         Session.Add("Raining", "0.0")
         Session.Add("AmbientTemp", "0.0")
         Session.Add("TrackTemp", "0.0")
         Session.Add("Wind", "0.0::0.0::0.0")
         Session.Add("OnPathWetness", "0.0")
         Session.Add("OffPathWetness", "0.0")
         Session.Add("TopS1", "0.0")
         Session.Add("TopS2", "0.0")
         Session.Add("TopLap", "0.0")
         XmlSessionInfos = XmlDoc.SelectNodes("rFactorScoring/SessionInfo")
         For Each SessionInfo As XmlNode In XmlSessionInfos
            If XmlSessionInfos.Count > 0 Then
               Session("GameID") = SessionInfo.SelectSingleNode("rFactorID").InnerXml
               Session("GameVersion") = SessionInfo.SelectSingleNode("rFactorVersion").InnerXml
               Session("PluginVersion") = SessionInfo.SelectSingleNode("PluginVersion").InnerXml
               Session("ServerStart") = SessionInfo.SelectSingleNode("ServerStart").InnerXml
               Session("ServerState") = SessionInfo.SelectSingleNode("ServerState").InnerXml
               Session("SessionStart") = SessionInfo.SelectSingleNode("SessionStart").InnerXml
               Session("SessionID") = SessionInfo.SelectSingleNode("SessionID").InnerXml
               Session("SessionState") = SessionInfo.SelectSingleNode("SessionState").InnerXml
               Session("SessionTime") = SessionInfo.SelectSingleNode("SessionTime").InnerXml
               Session("SessionEnd") = SessionInfo.SelectSingleNode("SessionEnd").InnerXml
               Session("MaxLaps") = SessionInfo.SelectSingleNode("MaxLaps").InnerXml
               Session("TrackName") = SessionInfo.SelectSingleNode("TrackName").InnerXml
               Session("TrackLength") = SessionInfo.SelectSingleNode("TrackLength").InnerXml
               Session("NumVehicles") = SessionInfo.SelectSingleNode("NumVehicles").InnerXml
               Session("InGameStart") = SessionInfo.SelectSingleNode("InGameStart").InnerXml
               Session("YellowFlagState") = SessionInfo.SelectSingleNode("YellowFlagState").InnerXml
               Session("SectorFlags") = SessionInfo.SelectSingleNode("SectorFlags").InnerXml
               Session("InRealtime") = SessionInfo.SelectSingleNode("InRealtime").InnerXml
               Session("StartLight") = SessionInfo.SelectSingleNode("StartLight").InnerXml
               Session("NumRedLights") = SessionInfo.SelectSingleNode("NumRedLights").InnerXml
               Session("PlayerName") = SessionInfo.SelectSingleNode("PlayerName").InnerXml
               Session("PlrFileName") = SessionInfo.SelectSingleNode("PlrFileName").InnerXml
               Session("DarkCloud") = SessionInfo.SelectSingleNode("DarkCloud").InnerXml
               Session("Raining") = SessionInfo.SelectSingleNode("Raining").InnerXml
               Session("AmbientTemp") = SessionInfo.SelectSingleNode("AmbientTemp").InnerXml
               Session("TrackTemp") = SessionInfo.SelectSingleNode("TrackTemp").InnerXml
               Session("Wind") = SessionInfo.SelectSingleNode("Wind").InnerXml
               Session("OnPathWetness") = SessionInfo.SelectSingleNode("OnPathWetness").InnerXml
               Session("OffPathWetness") = SessionInfo.SelectSingleNode("OffPathWetness").InnerXml
            End If
         Next
         Return 0
      Catch ex As Exception
         WriteLogFile("e", "{XmlGetSessionInfos} Uncaught exception (uups - shit happens): " & ex.Message)
         Return -1
      Finally
         XmlSessionInfos = Nothing
      End Try
   End Function

   Private Function XmlWriteGridInfo(ByRef XmlDoc As XmlDocument) As Boolean
      Dim CurLaps As Integer = 0
      Dim TopLap As Double = 2147483647D
      Dim GridInfoFileName As String = ""
      Dim SessionName As String = ""
      Dim UTF8NoBom As Encoding = New UTF8Encoding(False)
      Dim XmlSlots As XmlNodeList
      Dim XmlGridInfoData As String = ""

      Dim GridInfoPlace As Integer = 0
      Dim GridInfoLaps As Integer = 0
      Dim WriteGridInfoLap As Boolean = False

      Try
         If CStr2Int(Session("SessionState")) >= 5 Then
            SessionName = UtilSetSessionName(Session("GameID"), Session("SessionID"))
            GridInfoFileName = Session("SessionStart") & "-" & SessionName.Replace(" ", "-") & ".xml"

            XmlGridInfoData &= "<?xml version=""1.0"" encoding=""UTF-8""?>" & vbCrLf & _
                               "<rFactorGridInfo>" & vbCrLf & _
                               "<rFactorID>" & Session("GameID") & "</rFactorID>" & vbCrLf & _
                               "<LastUpdate>" & UtilNow(Now) & "</LastUpdate>" & vbCrLf & _
                               "<ServerStart>" & Session("ServerStart") & "</ServerStart>" & vbCrLf & _
                               "<SessionStart>" & Session("SessionStart") & "</SessionStart>" & vbCrLf & _
                               "<SessionName>" & SessionName & "</SessionName>" & vbCrLf & _
                               "<SessionState>" & UtilSetSessionState(Session("SessionState")) & "</SessionState>" & vbCrLf & _
                               "<SessionTime>" & Session("SessionTime") & "</SessionTime>" & vbCrLf & _
                               "<SessionEnd>" & Session("SessionEnd") & "</SessionEnd>" & vbCrLf & _
                               "<MaxLaps>" & Session("MaxLaps") & "</MaxLaps>" & vbCrLf & _
                               "<NumVehicles>" & Session("NumVehicles") & "</NumVehicles>" & vbCrLf & _
                               "<TrackLength>" & Session("TrackLength") & "</TrackLength>" & vbCrLf & _
                               "<Drivers>" & vbCrLf

            XmlSlots = XmlDoc.SelectNodes("rFactorScoring/Slots/Slot")
            If XmlSlots.Count > 0 Then
               For Each XmlSlot As XmlNode In XmlSlots
                  If CStr2Int(XmlSlot.SelectSingleNode("Laps").InnerXml) > CurLaps Then
                     CurLaps = CStr2Int(XmlSlot.SelectSingleNode("Laps").InnerXml)
                     Session("CurLaps") = XmlSlot.SelectSingleNode("Laps").InnerXml
                  End If

                  If CStr2Dbl(XmlSlot.SelectSingleNode("BestLap").InnerXml) > 0.0R And CStr2Dbl(XmlSlot.SelectSingleNode("BestLap").InnerXml) < TopLap Then
                     TopLap = CStr2Dbl(XmlSlot.SelectSingleNode("BestLap").InnerXml)
                     Session("TopS1") = XmlSlot.SelectSingleNode("BestS1").InnerXml
                     Session("TopS2") = UtilCalcSectorTime(XmlSlot.SelectSingleNode("BestS2").InnerXml, XmlSlot.SelectSingleNode("BestS1").InnerXml)
                     Session("TopLap") = XmlSlot.SelectSingleNode("BestLap").InnerXml
                  End If

                  Dim SessionLap As New XLap
                  SessionLap.KeyName = XmlSlot.SelectSingleNode("DriverName").InnerXml
                  SessionLap.LapNo = XmlSlot.SelectSingleNode("Laps").InnerXml
                  SessionLap.S1 = XmlSlot.SelectSingleNode("LastS1").InnerXml
                  SessionLap.S2 = UtilCalcSectorTime(XmlSlot.SelectSingleNode("LastS2").InnerXml, XmlSlot.SelectSingleNode("LastS1").InnerXml)
                  SessionLap.S3 = UtilCalcSectorTime(XmlSlot.SelectSingleNode("LastS3").InnerXml, XmlSlot.SelectSingleNode("LastS2").InnerXml)
                  SessionLap.LapTime = XmlSlot.SelectSingleNode("LastLap").InnerXml

                  GridInfoPlace = CInt(XmlSlot.SelectSingleNode("Place").InnerXml)
                  GridInfoLaps = CInt(XmlSlot.SelectSingleNode("Laps").InnerXml)

                  If GridInfoPlace = 1 Then
                     If GridInfoLaps > TotalLapsPos1 Then
                        TotalLapsPos1 = GridInfoLaps

                        WriteGridInfoLap = True
                     End If
                  End If

                  XmlGridInfoData &= "<Driver>" & vbCrLf & _
                                     " <Place>" & XmlSlot.SelectSingleNode("Place").InnerXml & "</Place>" & vbCrLf & _
                                     " <DriverName>" & XmlSlot.SelectSingleNode("DriverName").InnerXml & "</DriverName>" & vbCrLf & _
                                     " <VehicleClass>" & XmlSlot.SelectSingleNode("VehicleClass").InnerXml & "</VehicleClass>" & vbCrLf & _
                                     " <VehicleName>" & XmlSlot.SelectSingleNode("VehicleName").InnerXml & "</VehicleName>" & vbCrLf & _
                                     " <Laps>" & XmlSlot.SelectSingleNode("Laps").InnerXml & "</Laps>" & vbCrLf & _
                                     " <GapLaps>" & XmlSlot.SelectSingleNode("GapLaps").InnerXml & "</GapLaps>" & vbCrLf & _
                                     " <IntLaps>" & XmlSlot.SelectSingleNode("IntLaps").InnerXml & "</IntLaps>" & vbCrLf & _
                                     " <LapDist>" & XmlSlot.SelectSingleNode("LapDist").InnerXml & "</LapDist>" & vbCrLf & _
                                     " <InPits>" & XmlSlot.SelectSingleNode("InPits").InnerXml & "</InPits>" & vbCrLf & _
                                     " <FinishStatus>" & XmlSlot.SelectSingleNode("FinishStatus").InnerXml & "</FinishStatus>" & vbCrLf & _
                                     "</Driver>" & vbCrLf

                  If CStr2Dbl(SessionLap.S1) > 0.0R And CStr2Dbl(SessionLap.S2) > 0.0R And CStr2Dbl(SessionLap.LapTime) > 0.0R Then
                     If LapCache.ContainsKey(SessionLap.KeyName & SessionLap.LapTime) = False Then
                        LapCache.Add(SessionLap.KeyName & SessionLap.LapTime, SessionLap)
                     Else
                        LapCache(SessionLap.KeyName & SessionLap.LapTime) = SessionLap
                     End If
                  End If
               Next ' -- For Each XmlSlot As XmlNode In XmlSlots
            End If ' -- If XmlSlots.Count > 0 Then

            XmlGridInfoData &= "</Drivers>" & vbCrLf & _
                               "</rFactorGridInfo>" & vbCrLf

            My.Computer.FileSystem.WriteAllText(CurrentPath & DSC & APP_GRID_FOLDER & DSC & GridInfoFileName, XmlGridInfoData, False, UTF8NoBom)

            If WriteGridInfoLap = True Then
               Dim GridInfoFilePath As String = CurrentPath & DSC & APP_GRID_FOLDER & DSC & Now.ToString("yyyy-MM-dd-HH-mm-ss-") & SessionName & "-Lap-" & TotalLapsPos1.ToString().PadLeft(4, "0") & ".xml"

               My.Computer.FileSystem.WriteAllText(GridInfoFilePath, XmlGridInfoData, False, UTF8NoBom)
            End If
         End If

         Return True
      Catch ex As Exception
         WriteLogFile("e", "{XmlWriteGridInfo} " & ex.Message)
         Return False
      Finally
         UTF8NoBom = Nothing
         XmlSlots = Nothing
         XmlGridInfoData = Nothing
      End Try
   End Function

   Public Function UtilLoadTrackData(ByVal fileTrackData As String) As String
      Try
         Dim aiwTrackDataFileInfo As System.IO.FileInfo = My.Computer.FileSystem.GetFileInfo(APP_TRACK_FOLDER & DSC & fileTrackData)
         Dim aiwTrackName As String = fileTrackData.Replace(aiwTrackDataFileInfo.Extension, "")

         Dim listTrackData As New List(Of String)

         Dim waypointsTotal As String = ""

         Dim trackPosXMin As Double = 2147483647
         Dim trackPosXMax As Double = 0.0R
         Dim trackPosYMin As Double = 2147483647
         Dim trackPosYMax As Double = 0.0R
         Dim trackPosXMinY As Double = 0.0R
         Dim trackPosYMinX As Double = 0.0R

         rFactorSLTrackData.labelProgessInfo.Text = "Progress Info: Analyzing AIW data ..."
         rFactorSLTrackData.labelProgessInfo.Refresh()

         Using sr As System.IO.StreamReader = New System.IO.StreamReader(APP_TRACK_FOLDER & DSC & fileTrackData, System.Text.Encoding.ASCII)
            Dim lineTrackData As String = ""
            Dim trackPosition As String = ""
            Dim trackSector As String = ""
            Dim trackBranchID As String = ""

            lineTrackData = sr.ReadLine

            Do While (Not lineTrackData Is Nothing)
               Try
                  lineTrackData = lineTrackData.ToLower
               Catch ex As Exception
                  ' -- just catch
               End Try

               If lineTrackData.Contains("number_waypoints=") Then
                  waypointsTotal = lineTrackData.Replace("number_waypoints=", "")
               End If

               If lineTrackData.Contains("wp_pos=") Then
                  trackPosition = ""

                  Dim wpPos As String = Trim(lineTrackData)

                  Dim i As Integer = InStr(wpPos, "//")
                  If i > 0 Then
                     wpPos = Trim(wpPos.Substring(0, i - 1))
                  End If

                  Dim posValues As String = wpPos.Replace("wp_pos=(", "")
                  posValues = posValues.Replace(")", "")

                  Dim posArray() As String = Split(posValues, ",")
                  trackPosition = posArray(0) & "::" & posArray(2)
               End If

               If lineTrackData.Contains("wp_score=") Then
                  trackSector = ""

                  Dim wpScore As String = Trim(lineTrackData)

                  Dim i As Integer = InStr(wpScore, "//")
                  If i > 0 Then
                     wpScore = Trim(wpScore.Substring(0, i - 1))
                  End If

                  Dim scoreValues As String = wpScore.Replace("wp_score=(", "")
                  scoreValues = scoreValues.Replace(")", "")

                  Dim scoreArray() As String = Split(scoreValues, ",")
                  trackSector = scoreArray(0) & "::" & scoreArray(1)
               End If

               If lineTrackData.Contains("wp_branchid=") Then
                  trackBranchID = ""

                  Dim wpBranchID As String = Trim(lineTrackData)

                  Dim i As Integer = InStr(wpBranchID, "//")
                  If i > 0 Then
                     wpBranchID = Trim(wpBranchID.Substring(0, i - 1))
                  End If

                  Dim branchIDValue As String = wpBranchID.Replace("wp_branchid=(", "")
                  branchIDValue = branchIDValue.Replace(")", "")

                  trackBranchID = branchIDValue
               End If

               ' -- If trackPosition <> "" And trackSector <> "" Then
               If trackPosition <> "" And trackSector <> "" And trackBranchID <> "" Then
                  listTrackData.Add(trackPosition & "::" & trackSector & "::" & trackBranchID)

                  Dim trackPositionArray() As String = Split(trackPosition, "::")

                  ' -- determine track map edges
                  If CStr2Dbl(trackPositionArray(0)) < trackPosXMin Then
                     trackPosXMin = CStr2Dbl(trackPositionArray(0))
                     trackPosXMinY = CStr2Dbl(trackPositionArray(1))
                  End If

                  If CStr2Dbl(trackPositionArray(0)) > trackPosXMax Then trackPosXMax = CStr2Dbl(trackPositionArray(0))

                  If CStr2Dbl(trackPositionArray(1)) < trackPosYMin Then
                     trackPosYMin = CStr2Dbl(trackPositionArray(1))
                     trackPosYMinX = CStr2Dbl(trackPositionArray(0))
                  End If

                  If CStr2Dbl(trackPositionArray(1)) > trackPosYMax Then trackPosYMax = CStr2Dbl(trackPositionArray(1))

                  ' -- reset variables for next cycle
                  trackPosition = ""
                  trackSector = ""
                  trackBranchID = ""
               End If

               lineTrackData = sr.ReadLine
            Loop
         End Using

         rFactorSLTrackData.labelProgessInfo.Text = "Progress Info: Loading track data ..."
         rFactorSLTrackData.labelProgessInfo.Refresh()

         Dim waypointNumber As Integer = 1

         Dim mysqlConnection As MySqlConnection = SqlConnOpen()
         If mysqlConnection.State = ConnectionState.Open Then
            SqlTrackDataDelete(mysqlConnection, aiwTrackName)

            For Each TrackPositionData As String In listTrackData
               rFactorSLTrackData.labelProgessInfo.Text = "Progress Info: Loading waypoint #" & waypointNumber & " ..."
               rFactorSLTrackData.labelProgessInfo.Refresh()

               Dim positionData() As String = Split(TrackPositionData, "::")
               SqlTrackDataInsert(mysqlConnection, aiwTrackName, CStr2Dbl(positionData(3)), positionData(2), CStr2Dbl(positionData(0)), CStr2Dbl(positionData(1)), positionData(4))

               waypointNumber += 1
            Next

            If SqlTrackConfigGetByUnique(mysqlConnection, aiwTrackName) = False Then
               SqlTrackConfigInsert(mysqlConnection, aiwTrackName, trackPosXMin, trackPosXMax, trackPosYMin, trackPosYMax, trackPosXMinY, trackPosYMinX)
            Else
               SqlTrackConfigUpdate(mysqlConnection, aiwTrackName, trackPosXMin, trackPosXMax, trackPosYMin, trackPosYMax, trackPosXMinY, trackPosYMinX)
            End If

            If mysqlConnection.State <> ConnectionState.Closed Then
               SqlConnClose(mysqlConnection)
            End If
         End If

         rFactorSLTrackData.labelProgessInfo.Text = "Progress Info: Done - Processed " & waypointNumber - 1 & " of " & waypointsTotal & " waypoints."
         rFactorSLTrackData.labelProgessInfo.Refresh()

         Return True
      Catch ex As Exception
         WriteLogFile("e", "{UtilLoadTrackData} " & ex.Message)
         Return False
      End Try
   End Function

   Private Function UtilSetSessionStatus(ByVal SessionTime As String, ByVal SessionEnd As String, ByVal CompletedLaps As String, ByVal MaxLaps As String) As String
      Dim SessionStatus As String = "00:00:00"
      Dim SessionLaps As String = ""
      Try
         Dim SessionTimeLeft As Double = CStr2Dbl(SessionEnd) - CStr2Dbl(SessionTime)

         If CStr2Int(MaxLaps) < 2147483647 Then
            SessionLaps = " (" & CompletedLaps & "/" & MaxLaps & " Laps)"
         End If

         If SessionTimeLeft > 0 Then
            Dim SessionHrs As String = Math.Floor(SessionTimeLeft / 3600.0).ToString("00")
            Dim SessionMin As String = Math.Floor((SessionTimeLeft Mod 3600.0) / 60.0).ToString("00")
            Dim SessionSec As String = Math.Floor(SessionTimeLeft Mod 60.0).ToString("00")
            SessionStatus = SessionHrs & ":" & SessionMin & ":" & SessionSec
         End If

         Return SessionStatus & SessionLaps
      Catch ex As Exception
         WriteLogFile("e", "{UtilSetSessionStatus} " & ex.Message)
         Return "ERROR"
      End Try
   End Function

   Private Function UtilNow(ByVal dateNow As Date) As String
      Try
         Return Format(dateNow, "yyyy-MM-dd HH:mm:ss.fff")
      Catch ex As Exception
         WriteLogFile("e", "{UtilNow} " & ex.Message)
         Return dateNow.ToString
      End Try
   End Function

   Private Sub buttonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonStart.Click
      If bgWorkerMain.IsBusy = False Then
         UtilStartLoader()
      End If
   End Sub

   Private Sub buttonStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonStop.Click
      If buttonStart.Enabled = False Then
         If MessageBox.Show("Do you really want to stop the rFactor Session Loader?", Me.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
            UtilMonitorAdd("Stopping rFactor Session Loader. Please wait ...")
            StopLoader = True
            labelSQLState.Text = "SQL Connection State: Closed"
         End If
      End If
   End Sub

   Private Sub buttonExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonExit.Click
      Application.Exit()
   End Sub

   Private Function SqlConnOpen() As MySqlConnection
      Dim SqlConn As New MySqlConnection
      Try
         SqlConn.ConnectionString = SqlConnString
         SqlConn.Open()
         Return SqlConn
      Catch ex As Exception
         WriteLogFile("e", "{SqlConnOpen} " & ex.Message)
         If SqlConn.State <> ConnectionState.Closed Then
            MySqlClient.MySqlConnection.ClearPool(SqlConn)
            WriteLogFile("e", "{SqlConnOpen} Trying to close connection correctly due to error on Open() connection procedure.")
            SqlConnClose(SqlConn)
         End If
         Return SqlConn
      End Try
   End Function

   Private Function SqlConnClose(ByRef SqlConn As MySqlConnection) As Boolean
      Try
         If SqlConn.State <> ConnectionState.Closed Then
            SqlConn.Close()
         End If
         SqlConn.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlConnClose} " & ex.Message)
         SqlConn.Dispose()
         Return False
      End Try
   End Function

   Private Function SqlSessionUpdate(ByRef SqlConn As MySqlConnection) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = ""
      Dim SqlNonQueryReturn As Object
      Try
         SqlQuery = "UPDATE `sessioninfos` SET `LoaderVersion` = 'rFactorSL " & APP_VERSION & "'," & _
                                                     "`GameID` = '" & Session("GameID") & "'," & _
                                                "`GameVersion` = '" & Session("GameVersion") & "'," & _
                                              "`PluginVersion` = '" & Session("PluginVersion") & "'," & _
                                                "`ServerStart` = '" & Session("ServerStart") & "'," & _
                                                "`ServerState` = '" & Session("ServerState") & "'," & _
                                               "`SessionStart` = '" & Session("SessionStart") & "'," & _
                                                  "`SessionID` = '" & Session("SessionID") & "'," & _
                                               "`SessionState` = '" & Session("SessionState") & "'," & _
                                                "`SessionTime` = '" & Session("SessionTime") & "'," & _
                                                 "`SessionEnd` = '" & Session("SessionEnd") & "'," & _
                                                    "`CurLaps` = '" & Session("CurLaps") & "'," & _
                                                    "`MaxLaps` = '" & Session("MaxLaps") & "'," & _
                                                  "`TrackName` = '" & MySqlHelper.EscapeString(Session("TrackName")) & "'," & _
                                                "`TrackLength` = '" & Session("TrackLength") & "'," & _
                                                "`NumVehicles` = '" & Session("NumVehicles") & "'," & _
                                                "`InGameStart` = '" & Session("InGameStart") & "'," & _
                                            "`YellowFlagState` = '" & Session("YellowFlagState") & "'," & _
                                                "`SectorFlags` = '" & Session("SectorFlags") & "'," & _
                                                 "`InRealtime` = '" & Session("InRealtime") & "'," & _
                                                 "`StartLight` = '" & Session("StartLight") & "'," & _
                                               "`NumRedLights` = '" & Session("NumRedLights") & "'," & _
                                                 "`PlayerName` = '" & MySqlHelper.EscapeString(Session("PlayerName")) & "'," & _
                                                "`PlrFileName` = '" & MySqlHelper.EscapeString(Session("PlrFileName")) & "'," & _
                                                  "`DarkCloud` = '" & Session("DarkCloud") & "'," & _
                                                    "`Raining` = '" & Session("Raining") & "'," & _
                                                "`AmbientTemp` = '" & Session("AmbientTemp") & "'," & _
                                                  "`TrackTemp` = '" & Session("TrackTemp") & "'," & _
                                                       "`Wind` = '" & Session("Wind") & "'," & _
                                              "`OnPathWetness` = '" & Session("OnPathWetness") & "'," & _
                                             "`OffPathWetness` = '" & Session("OffPathWetness") & "', " & _
                                                    "`CurLaps` = '" & Session("CurLaps") & "', " & _
                                                      "`TopS1` = '" & Session("TopS1") & "', " & _
                                                      "`TopS2` = '" & Session("TopS2") & "', " & _
                                                     "`TopLap` = '" & Session("TopLap") & "', " & _
                                                 "`ConnPrefix` = '" & Config("connPrefix") & "', " & _
                                                "`ConnAddress` = '" & Config("connAddress") & "', " & _
                                                   "`ConnPort` = '" & Config("connPort") & "' " & _
                                                   "WHERE `ID` = '1'"
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlSessionUpdate} Msg : " & ex.Message & " Query: (" & SqlQuery & ")")
         Return False
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlNonQueryReturn = Nothing
      End Try
   End Function

   Private Function SqlSessionUpdateStatus(ByRef SqlConn As MySqlConnection, ByVal ServerState As String, ByVal SessionStart As String) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = "UPDATE `sessioninfos` SET `ServerState` = '" & ServerState & "', `SessionStart` = '" & SessionStart & "' WHERE `ID` = '1'"
      Dim SqlNonQueryReturn As Object
      Try
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlSessionUpdateStatus} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlNonQueryReturn = Nothing
      End Try
   End Function

   Private Function SqlLapsGetLapNo(ByRef SqlConn As MySqlConnection, ByVal SlotID As String, ByVal DriverName As String) As Integer
      Dim SqlCmd As New MySqlCommand
      Dim SqlQuery As String = "SELECT MAX(`LapNo`) AS `LapNo` FROM `racelaps` WHERE `SlotID` = '" & SlotID & "' LIMIT 1"
      If LapsTable = "xlaps" Then
         SqlQuery = "SELECT MAX(`LapNo`) AS `LapNo` FROM `xlaps` WHERE `DriverName` = '" + MySqlHelper.EscapeString(DriverName) + "' LIMIT 1"
      End If
      Dim SqlScalarValue As Object
      Dim SqlLapNo As Integer = 0
      Try
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlScalarValue = SqlCmd.ExecuteScalar()
         If SqlScalarValue IsNot Nothing And IsNumeric(SqlScalarValue) Then
            SqlLapNo = SqlScalarValue
         End If
         SqlCmd.Dispose()
         Return SqlLapNo
      Catch ex As Exception
         WriteLogFile("e", "{SqlLapsGetLapNo} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return -1
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlScalarValue = Nothing
      End Try
   End Function

   Private Function SqlSlotsInsert(ByRef SqlConn As MySqlConnection, ByVal SlotData As Dictionary(Of String, String)) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = ""
      Dim SqlNonQueryReturn As Object
      Try
         SqlQuery = "INSERT INTO `slots` SET `SlotID` = '" & SlotData("SlotID") & "'," & _
                                             "`Place` = '" & SlotData("Place") & "'," & _
                                        "`DriverName` = '" & MySqlHelper.EscapeString(SlotData("DriverName")) & "'," & _
                                      "`VehicleClass` = '" & MySqlHelper.EscapeString(SlotData("VehicleClass")) & "'," & _
                                           "`Vehicle` = '" & MySqlHelper.EscapeString(SlotData("VehicleName")) & "'," & _
                                           "`Control` = '" & SlotData("Control") & "'," & _
                                              "`Laps` = '" & SlotData("Laps") & "'," & _
                                            "`Sector` = '" & SlotData("Sector") & "'," & _
                                          "`LapStart` = '" & SlotData("LapStart") & "'," & _
                                           "`LapDist` = '" & SlotData("LapDist") & "'," & _
                                             "`CurS1` = '" & SlotData("CurS1") & "'," & _
                                             "`CurS2` = '" & SlotData("CurS2") & "'," & _
                                            "`LastS1` = '" & SlotData("LastS1") & "'," & _
                                            "`LastS2` = '" & SlotData("LastS2") & "'," & _
                                            "`LastS3` = '" & SlotData("LastS3") & "'," & _
                                           "`LastLap` = '" & SlotData("LastLap") & "'," & _
                                            "`BestS1` = '" & SlotData("BestS1") & "'," & _
                                            "`BestS2` = '" & SlotData("BestS2") & "'," & _
                                            "`BestS3` = '" & SlotData("BestS3") & "'," & _
                                           "`BestLap` = '" & SlotData("BestLap") & "'," & _
                                           "`GapTime` = '" & SlotData("GapTime") & "'," & _
                                           "`GapLaps` = '" & SlotData("GapLaps") & "'," & _
                                           "`IntTime` = '" & SlotData("IntTime") & "'," & _
                                           "`IntLaps` = '" & SlotData("IntLaps") & "'," & _
                                            "`InPits` = '" & SlotData("InPits") & "'," & _
                                             "`InBox` = '" & SlotData("InBox") & "'," & _
                                          "`Pitstops` = '" & SlotData("Pitstops") & "'," & _
                                         "`Penalties` = '" & SlotData("Penalties") & "'," & _
                                      "`FinishStatus` = '" & SlotData("FinishStatus") & "'," & _
                                      "`VehicleSpeed` = '" & SlotData("VehicleSpeed") & "'," & _
                                              "`PosX` = '" & SlotData("PosX") & "'," & _
                                              "`PosY` = '" & SlotData("PosY") & "'"
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlSlotsInsert} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlNonQueryReturn = Nothing
         SlotData = Nothing
      End Try
   End Function

   Private Function SqlLapsInsert(ByRef SqlConn As MySqlConnection, ByVal TableName As String, ByVal SlotData As Dictionary(Of String, String)) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = ""
      Dim SqlNonQueryReturn As Object
      Try
         SqlQuery = "INSERT INTO `" & TableName & "` SET `SlotID` = '" & SlotData("SlotID") & "', " & _
                                                    "`DriverName` = '" & MySqlHelper.EscapeString(SlotData("DriverName")) & "', " & _
                                                  "`VehicleClass` = '" & MySqlHelper.EscapeString(SlotData("VehicleClass")) & "', " & _
                                                       "`Vehicle` = '" & MySqlHelper.EscapeString(SlotData("VehicleName")) & "', " & _
                                                         "`LapNo` = '" & SlotData("Laps") & "', " & _
                                                          "`Sec1` = '" & SlotData("LastS1") & "', " & _
                                                          "`Sec2` = '" & SlotData("LastS2") & "', " & _
                                                          "`Sec3` = '" & SlotData("LastS3") & "', " & _
                                                       "`LapTime` = '" & SlotData("LastLap") & "', " & _
                                                        "`InPits` = '" & SlotData("InPits") & "', " & _
                                                    "`LastUpdate` = NOW()"
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlLapsInsert} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlNonQueryReturn = Nothing
         SlotData = Nothing
      End Try
   End Function

   Private Function SqlSlotsUpdate(ByRef SqlConn As MySqlConnection, ByVal SlotData As Dictionary(Of String, String)) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = ""
      Dim SqlNonQueryReturn As Object
      Try
         SqlQuery = "UPDATE `slots` SET `Place` = '" & SlotData("Place") & "'," & _
                                  "`DriverName` = '" & MySqlHelper.EscapeString(SlotData("DriverName")) & "'," & _
                                "`VehicleClass` = '" & MySqlHelper.EscapeString(SlotData("VehicleClass")) & "'," & _
                                     "`Vehicle` = '" & MySqlHelper.EscapeString(SlotData("VehicleName")) & "'," & _
                                     "`Control` = '" & SlotData("Control") & "'," & _
                                        "`Laps` = '" & SlotData("Laps") & "'," & _
                                      "`Sector` = '" & SlotData("Sector") & "'," & _
                                    "`LapStart` = '" & SlotData("LapStart") & "'," & _
                                     "`LapDist` = '" & SlotData("LapDist") & "'," & _
                                       "`CurS1` = '" & SlotData("CurS1") & "'," & _
                                       "`CurS2` = '" & SlotData("CurS2") & "'," & _
                                      "`LastS1` = '" & SlotData("LastS1") & "'," & _
                                      "`LastS2` = '" & SlotData("LastS2") & "'," & _
                                      "`LastS3` = '" & SlotData("LastS3") & "'," & _
                                     "`LastLap` = '" & SlotData("LastLap") & "'," & _
                                      "`BestS1` = '" & SlotData("BestS1") & "'," & _
                                      "`BestS2` = '" & SlotData("BestS2") & "'," & _
                                      "`BestS3` = '" & SlotData("BestS3") & "'," & _
                                     "`BestLap` = '" & SlotData("BestLap") & "'," & _
                                     "`GapTime` = '" & SlotData("GapTime") & "'," & _
                                     "`GapLaps` = '" & SlotData("GapLaps") & "'," & _
                                     "`IntTime` = '" & SlotData("IntTime") & "'," & _
                                     "`IntLaps` = '" & SlotData("IntLaps") & "'," & _
                                      "`InPits` = '" & SlotData("InPits") & "'," & _
                                       "`InBox` = '" & SlotData("InBox") & "'," & _
                                    "`Pitstops` = '" & SlotData("Pitstops") & "'," & _
                                   "`Penalties` = '" & SlotData("Penalties") & "'," & _
                                "`FinishStatus` = '" & SlotData("FinishStatus") & "'," & _
                                "`VehicleSpeed` = '" & SlotData("VehicleSpeed") & "'," & _
                                        "`PosX` = '" & SlotData("PosX") & "'," & _
                                        "`PosY` = '" & SlotData("PosY") & "' " & _
                                "WHERE `SlotID` = '" & SlotData("SlotID") & "'"
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlSlotsUpdate} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlNonQueryReturn = Nothing
         SlotData = Nothing
      End Try
   End Function

   Private Function SqlSlotsDelete(ByRef SqlConn As MySqlConnection, ByVal SlotID As String) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = "DELETE FROM `slots` WHERE `SlotID` < '" & SlotID & "'"
      Dim SqlNonQueryReturn As Object
      If SlotID < 105 Then
         SqlQuery = "DELETE FROM `slots` WHERE `SlotID` = '" & SlotID & "'"
      End If
      Try
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlSlotsDelete} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlNonQueryReturn = Nothing
      End Try
   End Function

   Private Function SqlSlotsGetSlotIDs(ByRef SqlConn As MySqlConnection) As Dictionary(Of String, String)
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = "SELECT `SlotID`, `DriverName` FROM `slots`"
      Dim SqlRecords As MySqlDataReader
      Dim SqlSlotData As New Dictionary(Of String, String)
      Try
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlRecords = SqlCmd.ExecuteReader()
         If SqlRecords.HasRows = True Then
            While SqlRecords.Read
               Dim SqlSlotID As String = SqlRecords.GetInt32("SlotID").ToString()
               Dim SqlDriverName As String = SqlRecords.GetString("DriverName")
               If SqlSlotData.ContainsKey(SqlSlotID) = False Then
                  SqlSlotData.Add(SqlSlotID, SqlDriverName)
               End If
            End While
         End If
         SqlRecords.Close()
         SqlCmd.Dispose()
         Return SqlSlotData
      Catch ex As Exception
         WriteLogFile("e", "{SqlSlotsGetSlotIDs} " & ex.Message & " - Query: (" & SqlQuery & ")")
         SqlSlotData.Clear()
         Return SqlSlotData
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlRecords = Nothing
      End Try
   End Function

   Private Function SqlHotlapsGetStatus(ByRef SqlConn As MySqlConnection, ByVal SlotData As Dictionary(Of String, String)) As String
      Dim HotlapStatus As String = "NOTHING"

      If SlotData("Control") = "1" And Config("LogAI") <> "1" Then
         Return HotlapStatus
         Exit Function
      End If

      Dim HotlapLapNo As Integer = 0
      Dim HotlapLapTime As Double = 0.0R

      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = ""
      Dim SqlRecords As MySqlDataReader

      Try
         SqlQuery = "SELECT `LapNo`, `LapTime` " & _
                      "FROM `hotlaps` " & _
                     "WHERE `TrackName` = '" & MySqlHelper.EscapeString(Session("TrackName")) & "' " & _
                      "AND `DriverName` = '" & MySqlHelper.EscapeString(SlotData("DriverName")) & "' " & _
                    "AND `VehicleClass` = '" & MySqlHelper.EscapeString(SlotData("VehicleClass")) & "' LIMIT 1"

         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlRecords = SqlCmd.ExecuteReader()

         If SqlRecords.HasRows = True Then
            While SqlRecords.Read
               HotlapLapNo = SqlRecords.GetInt32("LapNo")
               HotlapLapTime = SqlRecords.GetDouble("LapTime")
            End While

            If CStr2Int(SlotData("Laps")) > HotlapLapNo And CStr2Dbl(SlotData("LastLap")) > 0.0R Then
               HotlapStatus = "UPCOUNT"
            End If

            If CStr2Dbl(SlotData("BestLap")) < HotlapLapTime Then
               HotlapStatus = "UPDATE"
            End If
         Else
            HotlapStatus = "INSERT"
         End If

         SqlRecords.Close()
         SqlCmd.Dispose()

         Return HotlapStatus
      Catch ex As Exception
         WriteLogFile("e", "{SqlHotlapsGetStatus} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return "ERROR"
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlRecords = Nothing
         SlotData = Nothing
      End Try
   End Function

   Private Function SqlHotlapsInsert(ByRef SqlConn As MySqlConnection, ByVal SlotData As Dictionary(Of String, String)) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = ""
      Dim SqlNonQueryReturn As Object
      Try
         Dim KeyName As String = SlotData("DriverName")
         Dim Sec1 As String = SlotData("BestS1")
         Dim Sec2 As String = SlotData("BestS2")
         Dim Sec3 As String = SlotData("BestS3")
         Dim LapTime As String = SlotData("BestLap")

         If LapCache.ContainsKey(KeyName & LapTime) = True Then
            Dim SessionLap As XLap
            SessionLap = LapCache(KeyName & LapTime)
            Sec1 = SessionLap.S1
            Sec2 = SessionLap.S2
            Sec3 = SessionLap.S3
         End If

         SqlQuery = "INSERT INTO `hotlaps` SET `TrackName` = '" & MySqlHelper.EscapeString(Session("TrackName")) & "', " & _
                                             "`DriverName` = '" & MySqlHelper.EscapeString(SlotData("DriverName")) & "', " & _
                                           "`VehicleClass` = '" & MySqlHelper.EscapeString(SlotData("VehicleClass")) & "', " & _
                                                "`Vehicle` = '" & MySqlHelper.EscapeString(SlotData("VehicleName")) & "', " & _
                                                  "`LapNo` = '" & SlotData("Laps") & "', " & _
                                              "`TimedLaps` = '1', " & _
                                              "`SessionID` = '" & Session("SessionID") & "', " & _
                                                   "`Sec1` = '" & Sec1 & "', " & _
                                                   "`Sec2` = '" & Sec2 & "', " & _
                                                   "`Sec3` = '" & Sec3 & "', " & _
                                                "`LapTime` = '" & LapTime & "', " & _
                                             "`LastUpdate` = NOW()"

         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlHotlapsInsert} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlNonQueryReturn = Nothing
         SlotData = Nothing
      End Try
   End Function

   Private Function SqlHotlapsUpdate(ByRef SqlConn As MySqlConnection, ByVal SlotData As Dictionary(Of String, String)) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = ""
      Dim SqlNonQueryReturn As Object
      Try
         Dim KeyName As String = SlotData("DriverName")
         Dim Sec1 As String = SlotData("BestS1")
         Dim Sec2 As String = SlotData("BestS2")
         Dim Sec3 As String = SlotData("BestS3")
         Dim LapTime As String = SlotData("BestLap")

         If LapCache.ContainsKey(KeyName & LapTime) = True Then
            Dim SessionLap As XLap
            SessionLap = LapCache(KeyName & LapTime)
            Sec1 = SessionLap.S1
            Sec2 = SessionLap.S2
            Sec3 = SessionLap.S3
         End If

         SqlQuery = "UPDATE `hotlaps` SET `Vehicle` = '" & MySqlHelper.EscapeString(SlotData("VehicleName")) & "', " & _
                                           "`LapNo` = '" & SlotData("Laps") & "', " & _
                                       "`TimedLaps` = (`TimedLaps` + 1), " & _
                                       "`SessionID` = '" & Session("SessionID") & "', " & _
                                            "`Sec1` = '" & Sec1 & "', " & _
                                            "`Sec2` = '" & Sec2 & "', " & _
                                            "`Sec3` = '" & Sec3 & "', " & _
                                         "`LapTime` = '" & LapTime & "', " & _
                                      "`LastUpdate` = NOW() " & _
                                 "WHERE `TrackName` = '" & MySqlHelper.EscapeString(Session("TrackName")) & "' " & _
                                  "AND `DriverName` = '" & MySqlHelper.EscapeString(SlotData("DriverName")) & "' " & _
                                "AND `VehicleClass` = '" & MySqlHelper.EscapeString(SlotData("VehicleClass")) & "'"

         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlHotlapsUpdate} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlNonQueryReturn = Nothing
         SlotData = Nothing
      End Try
   End Function

   Private Function SqlHotlapsUpcount(ByRef SqlConn As MySqlConnection, ByVal SlotData As Dictionary(Of String, String)) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = ""
      Dim SqlNonQueryReturn As Object
      Try
         SqlQuery = "UPDATE `hotlaps` SET `LapNo` = '" & SlotData("Laps") & "', " & _
                                     "`TimedLaps` = (`TimedLaps` + 1) " & _
                               "WHERE `TrackName` = '" & MySqlHelper.EscapeString(Session("TrackName")) & "' " & _
                                "AND `DriverName` = '" & MySqlHelper.EscapeString(SlotData("DriverName")) & "' " & _
                              "AND `VehicleClass` = '" & MySqlHelper.EscapeString(SlotData("VehicleClass")) & "'"
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlHotlapsUpcount} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlNonQueryReturn = Nothing
         SlotData = Nothing
      End Try
   End Function

   Private Function SqlHotlapsReset(ByRef SqlConn As MySqlConnection, ByVal DriverName As String) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = ""
      Dim SqlNonQueryReturn As Object
      Try
         SqlQuery = "UPDATE `hotlaps` SET `LapNo` = '0' WHERE `DriverName` = '" & MySqlHelper.EscapeString(DriverName) & "'"
         If DriverName = "RESETALL" Then
            SqlQuery = "UPDATE `hotlaps` SET `LapNo` = '0' WHERE `LapNo` != '0'"
         End If
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlHotlapsReset} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlNonQueryReturn = Nothing
      End Try
   End Function

   Private Function SqlGetDatabaseVersion(ByRef SqlConn As MySqlConnection) As String
      Dim DatabaseVersion As String = "0"
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = "SELECT `DatabaseVersion` FROM `sessioninfos` WHERE `ID` = '1' LIMIT 1"
      Dim SqlScalarValue As Object
      Try
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlScalarValue = SqlCmd.ExecuteScalar()
         If SqlScalarValue IsNot Nothing Then
            DatabaseVersion = SqlScalarValue.ToString()
         End If
         SqlScalarValue = Nothing
         SqlQuery = Nothing
         SqlCmd.Dispose()
         Return DatabaseVersion
      Catch ex As Exception
         WriteLogFile("e", "{SqlGetDatabaseVersion} " & ex.Message & " - Query: (" & SqlQuery & ")")
         SqlScalarValue = Nothing
         SqlQuery = Nothing
         SqlCmd = Nothing
         Return DatabaseVersion
      End Try
   End Function

   Private Function SqlSessionGetStartTime(ByRef SqlConn As MySqlConnection) As String
      Dim SessionStartTime As String = "-1"
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = "SELECT `SessionStart` FROM `sessioninfos` WHERE `ID` = '1' LIMIT 1"
      Dim SqlScalarValue As Object
      Try
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlScalarValue = SqlCmd.ExecuteScalar()
         If SqlScalarValue IsNot Nothing Then
            SessionStartTime = SqlScalarValue.ToString()
         End If
         SqlCmd.Dispose()
         Return SessionStartTime
      Catch ex As Exception
         WriteLogFile("e", "{SqlSessionGetStartTime} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return SessionStartTime
      Finally
         SqlCmd = Nothing
         SqlQuery = Nothing
         SqlScalarValue = Nothing
      End Try
   End Function

   Private Function SqlWriteScoring() As Integer
      Try
         Return 0
      Catch ex As Exception
         Return -1
      End Try
   End Function

   Private Function SqlClearTable(ByRef SqlConn As MySqlConnection, ByVal TableName As String) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = "DELETE FROM `" & TableName & "` WHERE `ID` != '0'"
      Dim SqlNonQueryReturn As Object
      Try
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlNonQueryReturn = Nothing
         SqlQuery = Nothing
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlClearTable} " & ex.Message & " - Query: (" & SqlQuery & ")")
         SqlNonQueryReturn = Nothing
         SqlQuery = Nothing
         SqlCmd = Nothing
         Return False
      End Try
   End Function

   Private Function SqlClearXLaps(ByRef SqlConn As MySqlConnection, ByVal DriverName As String) As Boolean
      Dim SqlCmd As MySqlCommand
      Dim SqlQuery As String = "DELETE FROM `xlaps` WHERE `DriverName` = '" & MySqlHelper.EscapeString(DriverName) & "'"
      Dim SqlNonQueryReturn As Object
      Try
         SqlCmd = New MySqlCommand(SqlQuery, SqlConn)
         SqlNonQueryReturn = SqlCmd.ExecuteNonQuery()
         SqlNonQueryReturn = Nothing
         SqlQuery = Nothing
         SqlCmd.Dispose()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlClearXLaps} " & ex.Message & " - Query: (" & SqlQuery & ")")
         SqlNonQueryReturn = Nothing
         SqlQuery = Nothing
         SqlCmd = Nothing
         Return False
      End Try
   End Function

   Private Function SqlTrackConfigGetByUnique(ByRef SqlConn As MySqlConnection, ByVal TrackName As String) As Boolean
      Dim SqlQuery As String = "SELECT `TrackName` FROM `trackconfig` WHERE `TrackName` = '" & TrackName & "'"
      Dim SqlCmd As New MySqlCommand(SqlQuery, SqlConn)
      Dim mysqlReaderTrackConfigGetByUnique As MySqlDataReader
      Try
         mysqlReaderTrackConfigGetByUnique = SqlCmd.ExecuteReader
         If mysqlReaderTrackConfigGetByUnique.HasRows = True Then
            mysqlReaderTrackConfigGetByUnique.Close()
            Return True
         Else
            mysqlReaderTrackConfigGetByUnique.Close()
            Return False
         End If
      Catch ex As Exception
         WriteLogFile("e", "{SqlTrackConfigGetByUnique} " & ex.Message & " - Query: (" & SqlQuery & ")")
      End Try
   End Function

   Private Function SqlTrackConfigInsert(ByRef SqlConn As MySqlConnection, _
                                         ByVal TrackName As String, _
                                         ByVal TrackPosXMin As Double, _
                                         ByVal TrackPosXMax As Double, _
                                         ByVal TrackPosYMin As Double, _
                                         ByVal TrackPosYMax As Double, _
                                         ByVal TrackPosXMinY As Double, _
                                         ByVal TrackPosYMinX As Double) As Boolean

      Dim SqlQuery As String = "INSERT INTO `trackconfig` (`TrackName`," & _
                                                              "`MapScale`," & _
                                                              "`MapRotation`," & _
                                                              "`MapMirrorX`," & _
                                                              "`TrackPosXMin`," & _
                                                              "`TrackPosXMax`," & _
                                                              "`TrackPosYMin`," & _
                                                              "`TrackPosYMax`," & _
                                                              "`TrackPosXMinY`," & _
                                                              "`TrackPosYMinX`) " & _
                                                  "VALUES ('" & TrackName & "'," & _
                                                              "'1.0'," & _
                                                              "'0'," & _
                                                              "'-1'," & _
                                                  "'" & CDbl2Str(TrackPosXMin) & "'," & _
                                                  "'" & CDbl2Str(TrackPosXMax) & "'," & _
                                                  "'" & CDbl2Str(TrackPosYMin) & "'," & _
                                                  "'" & CDbl2Str(TrackPosYMax) & "'," & _
                                                  "'" & CDbl2Str(TrackPosXMinY) & "'," & _
                                                  "'" & CDbl2Str(TrackPosYMinX) & "')"

      Dim SqlCmd As New MySqlCommand(SqlQuery, SqlConn)
      Dim mysqlReaderInsertTrackConfig As MySqlDataReader
      Try
         mysqlReaderInsertTrackConfig = SqlCmd.ExecuteReader
         mysqlReaderInsertTrackConfig.Close()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlTrackConfigInsert} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      End Try
   End Function

   Private Function SqlTrackConfigUpdate(ByRef SqlConn As MySqlConnection, _
                                         ByVal TrackName As String, _
                                         ByVal TrackPosXMin As Double, _
                                         ByVal TrackPosXMax As Double, _
                                         ByVal TrackPosYMin As Double, _
                                         ByVal TrackPosYMax As Double, _
                                         ByVal TrackPosXMinY As Double, _
                                         ByVal TrackPosYMinX As Double) As Boolean

      Dim SqlQuery As String = "UPDATE `trackconfig` SET `TrackPosXMin` = '" & CDbl2Str(TrackPosXMin) & "', " & _
                                                            "`TrackPosXMax` = '" & CDbl2Str(TrackPosXMax) & "', " & _
                                                            "`TrackPosYMin` = '" & CDbl2Str(TrackPosYMin) & "', " & _
                                                            "`TrackPosYMax` = '" & CDbl2Str(TrackPosYMax) & "', " & _
                                                            "`TrackPosXMinY` = '" & CDbl2Str(TrackPosXMinY) & "', " & _
                                                            "`TrackPosYMinX` = '" & CDbl2Str(TrackPosYMinX) & "' " & _
                                                      "WHERE `TrackName` = '" & TrackName & "'"

      Dim SqlCmd As New MySqlCommand(SqlQuery, SqlConn)
      Dim mysqlReaderTrackConfigUpdate As MySqlDataReader
      Try
         mysqlReaderTrackConfigUpdate = SqlCmd.ExecuteReader
         mysqlReaderTrackConfigUpdate.Close()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlTrackConfigUpdate} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      End Try
   End Function

   Private Function SqlTrackDataInsert(ByRef SqlConn As MySqlConnection, _
                                       ByVal TrackName As String, _
                                       ByVal LapDist As Double, _
                                       ByVal Sector As Integer, _
                                       ByVal PosX As Double, _
                                       ByVal PosY As Double, _
                                       ByVal BranchID As Integer) As Boolean

      Dim SqlQuery As String = "INSERT INTO `trackdata` (`TrackName`," & _
                                                            "`LapDist`," & _
                                                            "`Sector`," & _
                                                            "`PosX`," & _
                                                            "`PosY`," & _
                                                            "`BranchID`) " & _
                                                "VALUES ('" & TrackName & "'," & _
                                                        "'" & CDbl2Str(LapDist) & "'," & _
                                                        "'" & Sector & "'," & _
                                                        "'" & CDbl2Str(PosX) & "'," & _
                                                        "'" & CDbl2Str(PosY) & "'," & _
                                                        "'" & BranchID & "')"

      Dim SqlCmd As New MySqlCommand(SqlQuery, SqlConn)
      Dim mysqlReaderInsertTrackData As MySqlDataReader
      Try
         mysqlReaderInsertTrackData = SqlCmd.ExecuteReader
         mysqlReaderInsertTrackData.Close()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlTrackDataInsert} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      End Try
   End Function

   Private Function SqlTrackDataDelete(ByRef SqlConn As MySqlConnection, ByVal TrackName As String) As Boolean
      Dim SqlQuery As String = "DELETE FROM `trackdata` WHERE `TrackName` = '" & TrackName & "'"
      Dim SqlCmd As New MySqlCommand(SqlQuery, SqlConn)
      Dim mysqlReaderDeleteTrackData As MySqlDataReader
      Try
         mysqlReaderDeleteTrackData = SqlCmd.ExecuteReader
         mysqlReaderDeleteTrackData.Close()
         Return True
      Catch ex As Exception
         WriteLogFile("e", "{SqlTrackDataDelete} " & ex.Message & " - Query: (" & SqlQuery & ")")
         Return False
      End Try
   End Function

   Private Function WriteLogFile(ByVal MsgType As String, ByVal MsgText As String) As Integer
      Dim UTF8NoBom As Encoding
      Try
         Dim LogTime As String = Date.Now.ToString("yyyy-MM-dd HH:mm:ss.fff (K)")
         Select Case MsgType
            Case "e"
               MsgType = "ERROR  "
            Case "i"
               MsgType = "INFO   "
            Case "s"
               MsgType = "SUCCESS"
            Case "w"
               MsgType = "WARNING"
            Case Else
               MsgType = "UNKNOWN"
         End Select
         UTF8NoBom = New UTF8Encoding(False)
         My.Computer.FileSystem.WriteAllText(CurrentPath & DSC & APP_LOG_FILE, LogTime & " | " & MsgType & " | " & MsgText & vbCrLf, True, UTF8NoBom)
         Return 0
      Catch ex As Exception
         Return -1
      Finally
         UTF8NoBom = Nothing
      End Try
   End Function

   Private Function UtilFormatStartTime(ByVal StartTime As String) As String
      Try
         Dim ST() As String = Split(StartTime, "-", -1, CompareMethod.Text)
         Return ST(0) & "-" & ST(1) & "-" & ST(2) & " " & ST(3) & ":" & ST(4) & ":" & ST(5)
      Catch ex As Exception
         WriteLogFile("e", "{UtilFormatStartTime} " & ex.Message & " - Start Time: (" & StartTime & ")")
         Return StartTime
      End Try
   End Function

   Private Function UtilCalcSectorTime(ByVal SectorHigh As String, ByVal SectorLow As String) As String
      Dim SectorTime As String = "-1.000"
      Try
         Dim SH As Double = CStr2Dbl(SectorHigh)
         Dim SL As Double = CStr2Dbl(SectorLow)
         If SH > 0.0R And SL > 0.0R Then
            SectorTime = CDbl2Str(SH - SL)
         End If
         Return SectorTime
      Catch ex As Exception
         WriteLogFile("e", "{UtilCalcSectorTime} " & ex.Message & " - Sector High / Sector Low: (" & SectorHigh & " / " & SectorLow & ")")
         Return "-2.000"
      End Try
   End Function

   Private Function UtilCheckRequiredFiles() As Boolean
      Dim checkValid As Boolean = True
      If My.Computer.FileSystem.FileExists("MySql.Data.dll") = False Then
         checkValid = False
         MessageBox.Show("Required file `MySql.Data.dll` is missing.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Warning)
      Else
         Dim mysqlDataDll As FileVersionInfo = FileVersionInfo.GetVersionInfo("MySql.Data.dll")
         If mysqlDataDll.FileVersion <> "6.6.5.0" Then
            checkValid = False
            MessageBox.Show("Required file `MySql.Data.dll` has a wrong file version number.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Warning)
         End If
      End If
      Return checkValid
   End Function

   Private Function UtilSetSessionName(ByVal GameID As String, ByVal SessionID As String) As String
      Dim CurrentSessionName As String = "Unknown (" & SessionID & ")"

      LapsTable = "xlaps"

      If GameID = "1" Then
         Select Case SessionID
            Case "0"
               CurrentSessionName = "Test Day"
            Case "1"
               CurrentSessionName = "Practice 1"
            Case "2"
               CurrentSessionName = "Practice 2"
            Case "3"
               CurrentSessionName = "Practice 3"
            Case "4"
               CurrentSessionName = "Practice 4"
            Case "5"
               CurrentSessionName = "Qualifying"
            Case "6"
               CurrentSessionName = "Warmup"
            Case "7"
               CurrentSessionName = "Race"
               LapsTable = "racelaps"
         End Select
      End If

      If GameID = "2" Then
         Select Case SessionID
            Case "0"
               CurrentSessionName = "Test Day"
            Case "1"
               CurrentSessionName = "Practice 1"
            Case "2"
               CurrentSessionName = "Practice 2"
            Case "3"
               CurrentSessionName = "Practice 3"
            Case "4"
               CurrentSessionName = "Practice 4"
            Case "5"
               CurrentSessionName = "Qualifying 1"
            Case "6"
               CurrentSessionName = "Qualifying 2"
            Case "7"
               CurrentSessionName = "Qualifying 3"
            Case "8"
               CurrentSessionName = "Qualifying 4"
            Case "9"
               CurrentSessionName = "Warmup"
            Case "10"
               CurrentSessionName = "Race 1"
               LapsTable = "racelaps"
            Case "11"
               CurrentSessionName = "Race 2"
               LapsTable = "racelaps"
            Case "12"
               CurrentSessionName = "Race 3"
               LapsTable = "racelaps"
            Case "13"
               CurrentSessionName = "Race 4"
               LapsTable = "racelaps"
         End Select
      End If

      Return CurrentSessionName
   End Function

   Private Function UtilSetSessionState(ByVal SessionStateID As String) As String
      Dim CurrentSessionState As String = "Unknown (" & SessionStateID & ")"

      Select Case SessionStateID
         Case "0"
            CurrentSessionState = "Before Session"
         Case "1"
            CurrentSessionState = "Recon Lap"
         Case "2"
            CurrentSessionState = "Grid walk-through"
         Case "3"
            CurrentSessionState = "Formation Lap"
         Case "4"
            CurrentSessionState = "Countdown..."
         Case "5"
            CurrentSessionState = "Green Flag"
         Case "6"
            CurrentSessionState = "Full Course Yellow"
         Case "7"
            CurrentSessionState = "Session Stopped"
         Case "8"
            CurrentSessionState = "Finished"
      End Select

      Return CurrentSessionState
   End Function

   Private Function UtilGetDecimalSeparator() As String
      Dim GCI As Globalization.CultureInfo = Threading.Thread.CurrentThread.CurrentCulture
      Return GCI.NumberFormat.NumberDecimalSeparator
   End Function

   Private Sub UtilStartLoader()
      If UtilCheckRequiredFiles() = False Then
         Exit Sub
      End If
      UtilMonitorAdd("Starting rFactor Session Loader.")
      StopLoader = False
      bgWorkerMain.RunWorkerAsync()
      buttonStart.Enabled = False
      buttonExit.Enabled = False
   End Sub

   Private Sub UtilShowLog()
      Dim ProcInfo As ProcessStartInfo
      Try
         ProcInfo = New ProcessStartInfo
         ProcInfo.FileName = CurrentPath & DSC & APP_LOG_FILE
         Process.Start(ProcInfo)
      Catch ex As Exception
         WriteLogFile("e", "{ShowLog} " & ex.Message)
         ProcInfo = Nothing
      End Try
   End Sub

   Private Function CStr2Dbl(ByVal stringValue As String) As Double
      Return CDbl(Replace(stringValue, ".", CDS))
   End Function

   Private Function CStr2Int(ByVal Number As String) As Integer
      Try
         Return Convert.ToInt32(Number)
      Catch ex As Exception
         WriteLogFile("e", "{CStr2Int} " & ex.Message & " - Number: (" & Number & ")")
         Return -1
      End Try
   End Function

   Private Function CDbl2Str(ByVal doubleValue As Double) As String
      Return Replace(CStr(doubleValue), CDS, ".")
   End Function

   Private Sub bgWorkerMain_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles bgWorkerMain.DoWork
      Worker()
   End Sub

   Private Sub bgWorkerMain_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles bgWorkerMain.RunWorkerCompleted
      If StopLoader = False Then
         bgWorkerMain.RunWorkerAsync()
      Else
         UtilMonitorAdd("... rFactor Session Loader has been stopped.")
         FirstLoad = True
         buttonStart.Enabled = True
         buttonExit.Enabled = True
      End If
   End Sub

   Delegate Sub DelegateLabelWrite(ByVal Target As Label, ByVal StringValue As String)

   Public Sub ThreadLabelWrite(ByVal Target As Label, ByVal StringValue As String)
      Target.Text = StringValue
      Target.Refresh()
   End Sub

   Private Sub UtilLabelWriteText(ByRef controlName As Label, ByVal StringValue As String)
      Dim Params(1) As Object
      Params(0) = controlName
      Params(1) = StringValue
      Me.Invoke(New DelegateLabelWrite(AddressOf ThreadLabelWrite), Params)
   End Sub

   Delegate Sub DelegateListBoxWrite(ByVal Target As ListBox, ByVal StringValue As String)

   Public Sub ThreadListBoxAdd(ByVal Target As ListBox, ByVal StringValue As String)
      Target.Items.Add(StringValue)
      Target.SelectedIndex = Target.Items.Count - 1
      Target.Refresh()
   End Sub

   Private Sub UtilMonitorAdd(ByVal StringValue As String)
      Dim Params(1) As Object
      Params(0) = listboxMonitor
      Params(1) = StringValue
      Me.Invoke(New DelegateListBoxWrite(AddressOf ThreadListBoxAdd), Params)
   End Sub

   Private Sub toolstripToolsManageTrackData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolstripToolsManageTrackData.Click
      rFactorSLTrackData.ShowDialog()
   End Sub

   Private Sub toolstripToolsShowLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolstripToolsShowLog.Click
      UtilShowLog()
   End Sub

End Class
