﻿
Imports System.Windows.Forms
Imports rFactorSL.rFactorSLMain

Public Class rFactorSLTrackData

   Private Sub rFactorSLTrackData_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      Me.Text = "rFactor Session Loader (" & APP_VERSION & " beta) - Manage Track Data"
      If rFactorSLMain.bgWorkerMain.IsBusy = True Then
         MessageBox.Show("Please stop the rFactor Session Loader before managing track data!", "Manage Track Data ...", MessageBoxButtons.OK, MessageBoxIcon.Information, MessageBoxDefaultButton.Button1)
         Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
         Me.Close()
         Exit Sub
      End If
      UtilPopulateCombobox()
   End Sub

   Private Sub UtilPopulateCombobox()

      comboboxAIWFiles.Items.Clear()
      comboboxAIWFiles.Items.Add("Please select rFactor track data file ...")

      If My.Computer.FileSystem.DirectoryExists(APP_TRACK_FOLDER) = True Then
         Dim localFiles = My.Computer.FileSystem.GetFiles(APP_TRACK_FOLDER, FileIO.SearchOption.SearchTopLevelOnly)

         For Each localFile As String In localFiles
            Dim localFileInfo As System.IO.FileInfo = My.Computer.FileSystem.GetFileInfo(localFile)

            If localFileInfo.Extension.ToLower = ".aiw" Then
               comboboxAIWFiles.Items.Add(localFileInfo.Name)
            End If
         Next
      End If

      comboboxAIWFiles.SelectedIndex = 0

   End Sub

   Private Sub buttonLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonLoad.Click
      If My.Computer.FileSystem.FileExists(APP_TRACK_FOLDER & "\" & comboboxAIWFiles.Text) Then
         If rFactorSLMain.UtilLoadTrackData(comboboxAIWFiles.Text) = True Then
            MessageBox.Show("Track data file successfully loaded.", "Manage Track Data ...", MessageBoxButtons.OK, MessageBoxIcon.Information)
         Else
            MessageBox.Show("Error loading track data file. Please check log file for more infos.", "Manage Track Data ...", MessageBoxButtons.OK, MessageBoxIcon.Error)
         End If
      End If

      ' -- Me.DialogResult = System.Windows.Forms.DialogResult.OK
      ' -- Me.Close()
   End Sub

   Private Sub buttonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonClose.Click
      Me.DialogResult = System.Windows.Forms.DialogResult.None
      Me.Close()
   End Sub

   Private Sub comboboxAIWFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboboxAIWFiles.SelectedIndexChanged
      labelProgessInfo.Text = "Progress Info: "
   End Sub

End Class
